<template>
	<ProviderCustomColors
		:id="id"
		v-bind="getColorProps($props)"
		has-desktop-colors
		:class="[$style.block, $style[`${appearance}Appearance`]]"
		:style="backgroundColorStyles"
	>
		<div :class="$style.inner">
			<h2
				v-if="heading"
				class="u-font-secondary"
				:class="[$style.heading, { [$style.displayBelowMedium]: headingDesktop }]"
			>
				{{ heading }}
			</h2>
			<h2
				v-if="headingDesktop"
				class="u-font-secondary"
				:class="[$style.heading, { [$style.displayAboveMedium]: headingDesktop }]"
			>
				{{ headingDesktop }}
			</h2>

			<div :class="[$style.specs]">
				<dl :class="$style.spec">
					<div v-for="(item, index) in items" :key="index" :class="$style.specRow">
						<dt
							v-rich-content
							:class="[$style.specCol, $style.name]"
							:style="{ width: `${nameWidth}%` }"
							v-html="item.name"
						/>
						<dd
							v-rich-content
							:class="[$style.specCol, $style.value]"
							:style="{ width: `${valueWidth}%` }"
							v-html="item.value"
						/>
					</div>
				</dl>
			</div>
		</div>
	</ProviderCustomColors>
</template>

<script>
import ProviderCustomColors, { getColorProps } from '@components/provider-custom-colors';

export default {
	components: { ProviderCustomColors },

	props: {
		id: {
			type: String,
			default: null,
		},

		heading: {
			type: String,
			default: '',
		},

		headingDesktop: {
			type: String,
			default: '',
		},

		items: {
			type: Array,
			default: () => [],
		},

		mobileBackgroundColor: {
			type: String,
			default: '',
		},

		desktopBackgroundColor: {
			type: String,
			default: '',
		},

		nameWidth: {
			type: Number,
			default: 40,
		},

		valueWidth: {
			type: Number,
			default: 60,
		},

		appearance: {
			type: String,
			default: 'primary',
			validator: (v) => ['primary', 'secondary', 'tertiaty'].includes(v),
		},

		headingColor: {
			type: String,
			default: '',
		},

		copyColor: {
			type: String,
			default: '',
		},

		headingColorDesktop: {
			type: String,
			default: '',
		},

		copyColorDesktop: {
			type: String,
			default: '',
		},
	},

	computed: {
		backgroundColorStyles() {
			const { appearance } = this;

			return {
				'--mobile-background-color': this.mobileBackgroundColor
					? this.mobileBackgroundColor
					: appearance === 'primary'
					? '#f3f8f7'
					: '#ffffff',
				'--desktop-background-color': this.desktopBackgroundColor
					? this.desktopBackgroundColor
					: appearance === 'primary'
					? '#f3f8f7'
					: '#ffffff',
			};
		},
	},

	methods: { getColorProps },
};
</script>

<style lang="scss" module>
@import '@design';

$color-border: rgba(color('black'), 0.1);

@mixin responsive-bg-colors($default-color, $medium-color) {
	background-color: var($default-color);

	@include above('medium') {
		background-color: var($medium-color);
	}
}

.block {
	@include responsive-bg-colors(--mobile-background-color, --desktop-background-color);
}

.inner {
	max-width: 125rem;
	padding: size('m++') size('xs') size('m+');
	margin: 0 auto;

	@include above('medium') {
		padding: 6.5rem size('m-') 10rem;
	}
}

.heading {
	margin-bottom: 3.8rem;
	text-align: center;

	@include use-text-style('heading-500');

	@include above('medium') {
		margin-bottom: 7.2rem;
	}

	@include above('medium') {
		@include use-text-style('heading-600');
	}
}

.specs {
	max-width: 900px;
	margin: 0 auto;
}

.spec {
	@include use-text-style('type-100');

	font-weight: 300;
	line-height: 1.85714;
}

.specRow {
	display: flex;
	justify-content: flex-start;
	padding: size('xs') 0;
	border-bottom: 1px solid $color-border;

	&:first-child {
		border-top: 1px solid $color-border;
	}

	&:not(:last-child) {
		margin-bottom: size('xxs');

		@include above('medium') {
			margin-bottom: 0;
		}
	}

	@include above('medium') {
		padding: size('s') 0;
	}
}

.specCol {
	@include above('medium') {
		flex: 0 0 auto;
	}

	&.name {
		width: 40%;
		padding: 0 size('xxs') 0 0;

		@include above('medium') {
			width: 30%;
			padding: 0 size('s') 0 size('m+');
		}
	}

	&.value {
		flex: 1;
	}
	strong {
		font-weight: normal;
	}
}

.name {
	padding-bottom: 0.1rem;
	padding-left: size('s++');

	@include above('medium') {
		padding-bottom: 0;
		margin-bottom: 0;
		font-weight: 300;
		border-bottom: none;
	}
}

.value {
	p {
		&:not(:last-child) {
			margin-bottom: 1.25em;
		}
	}
}

.secondaryAppearance {
	.inner {
		padding: 4rem 4rem 2.5rem;

		@include above('large') {
			padding-bottom: 20.9rem;
		}
	}

	.heading {
		@include use-text-style('heading-180');

		@include above('medium') {
			margin-bottom: 4rem;
		}
	}

	.specRow {
		@include above('medium') {
			padding: 1.5rem 0 1.2rem;
		}
	}

	.specCol.name {
		@include above('medium') {
			padding-left: 2.9rem;
		}
	}

	.specRow:last-child {
		border-bottom: none;
	}
}

.displayBelowMedium {
	@include above('medium') {
		display: none;
	}
}

.displayAboveMedium {
	@include below('medium') {
		display: none;
	}
}
</style>
